commit 83fc95982d8838c33f1be57693c0db53e5d74b0f
Author: freddy77 <freddy77>
Date:   Thu Jan 28 13:31:51 2010 +0000

    improve (a lot!) log performance under windows using append mode

diff --git a/ChangeLog b/ChangeLog
index 4b2ee45..6801f79 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Thu Jan 28 14:30:21 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsthread.h src/tds/log.c:
+	- improve (a lot!) log performance under windows using append mode
+
 Thu Jan 28 14:14:04 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/net.c: does not overwrite error with other calls
 
@@ -2251,4 +2255,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2972 2010/01/28 13:15:20 freddy77 Exp $
+$Id: ChangeLog,v 1.2973 2010/01/28 13:31:51 freddy77 Exp $
diff --git a/include/tdsthread.h b/include/tdsthread.h
index c2e5c13..b4249f1 100644
--- a/include/tdsthread.h
+++ b/include/tdsthread.h
@@ -22,7 +22,9 @@
 #ifndef TDSTHREAD_H
 #define TDSTHREAD_H 1
 
-/* $Id: tdsthread.h,v 1.5 2010/01/27 15:32:04 freddy77 Exp $ */
+/* $Id: tdsthread.h,v 1.6 2010/01/28 13:31:51 freddy77 Exp $ */
+
+#undef TDS_HAVE_MUTEX
 
 #if defined(_THREAD_SAFE) && defined(TDS_HAVE_PTHREAD_MUTEX)
 
@@ -32,6 +34,8 @@
 #define TDS_MUTEX_LOCK(a) pthread_mutex_lock(a)
 #define TDS_MUTEX_UNLOCK(a) pthread_mutex_unlock(a)
 
+#define TDS_HAVE_MUTEX 1
+
 #elif defined(_WIN32)
 
 typedef struct tds_win_mutex_t_ {
@@ -48,6 +52,8 @@ void tds_win_mutex_lock(tds_win_mutex_t *mutex);
 	do { if ((a)->done) EnterCriticalSection(&(a)->crit); else tds_win_mutex_lock(a); } while(0)
 #define TDS_MUTEX_UNLOCK(a) LeaveCriticalSection(&(a)->crit)
 
+#define TDS_HAVE_MUTEX 1
+
 #else
 
 #define TDS_MUTEX_DEFINE(name) int name
diff --git a/src/tds/log.c b/src/tds/log.c
index c064963..335bf59 100644
--- a/src/tds/log.c
+++ b/src/tds/log.c
@@ -1,6 +1,6 @@
 /* FreeTDS - Library of routines accessing Sybase and Microsoft databases
  * Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005  Brian Bruns
- * Copyright (C) 2006-2008 Frediano Ziglio
+ * Copyright (C) 2006-2010  Frediano Ziglio
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Library General Public
@@ -66,7 +66,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: log.c,v 1.16 2010/01/11 18:00:16 freddy77 Exp $");
+TDS_RCSID(var, "$Id: log.c,v 1.17 2010/01/28 13:31:51 freddy77 Exp $");
 
 /* for now all messages go to the log */
 int tds_debug_flags = TDS_DBGFLAG_ALL | TDS_DBGFLAG_SOURCE;
@@ -154,7 +154,7 @@ tdsdump_open(const char *filename)
 	if (tds_g_append_mode) {
 		g_dump_filename = strdup(filename);
 		/* if mutex are available do not reopen file every time */
-#ifdef TDS_HAVE_PTHREAD_MUTEX
+#ifdef TDS_HAVE_MUTEX
 		g_dumpfile = tdsdump_append();
 #endif
 	} else if (!strcmp(filename, "stdout")) {
@@ -296,7 +296,7 @@ tdsdump_dump_buf(const char* file, unsigned int level_line, const char *msg, con
 	TDS_MUTEX_LOCK(&g_dump_mutex);
 
 	dumpfile = g_dumpfile;
-#ifdef TDS_HAVE_PTHREAD_MUTEX
+#ifdef TDS_HAVE_MUTEX
 	if (tds_g_append_mode && dumpfile == NULL)
 		dumpfile = g_dumpfile = tdsdump_append();
 #else
@@ -354,7 +354,7 @@ tdsdump_dump_buf(const char* file, unsigned int level_line, const char *msg, con
 
 	fflush(dumpfile);
 
-#ifndef TDS_HAVE_PTHREAD_MUTEX
+#ifndef TDS_HAVE_MUTEX
 	if (tds_g_append_mode) {
 		if (dumpfile != stdout && dumpfile != stderr)
 			fclose(dumpfile);
@@ -389,7 +389,7 @@ tdsdump_log(const char* file, unsigned int level_line, const char *fmt, ...)
 	TDS_MUTEX_LOCK(&g_dump_mutex);
 
 	dumpfile = g_dumpfile;
-#ifdef TDS_HAVE_PTHREAD_MUTEX
+#ifdef TDS_HAVE_MUTEX
 	if (tds_g_append_mode && dumpfile == NULL)
 		dumpfile = g_dumpfile = tdsdump_append();
 #else
@@ -411,7 +411,7 @@ tdsdump_log(const char* file, unsigned int level_line, const char *fmt, ...)
 
 	fflush(dumpfile);
 
-#ifndef TDS_HAVE_PTHREAD_MUTEX
+#ifndef TDS_HAVE_MUTEX
 	if (tds_g_append_mode) {
 		if (dumpfile != stdout && dumpfile != stderr)
 			fclose(dumpfile);

